// pages/confirmOrder/confirmOrder.js
const getReq = require('./../../config.js').getReq
import Bundle from '../../utils/Bundle'
let appInstance = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    goods_id: '',
    ifcart: '',
    num: '',
    datas: {},
    goods_list: [],
    firstLoad: true,
    defaultAddress: null,
    cart_id: '',
    n_goods_list: [],
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let goods_id = options.goods_id || ''
    let iscart = options.iscart || ''
    let num = options.num || ''
    let cart_id = options.cart_id || ''
    this.setData({
      goods_id,
      ifcart: iscart,
      num,
      cart_id
    })
    this.getDatas(goods_id, iscart, num, cart_id)

    // 测试套装数据
    //  this.getDatas(goods_id, 1, num, '16403,16406')
    //  act:member_buy
    // cart_id:16403,16406
    // op:step_first
    // from:YWN0PWNhcnQmb3A9ZXhnb29kcyZjdXJwYWdlPTE%3D
    // ifcart:1
  },
  getDatas(goods_id, ifcart, num, cart_id) {
    wx.showLoading({
      title: '加载中',
    })
    var self = this
    let goods_datas = '';
    if (ifcart == 0) {
      goods_datas = goods_id + '|' + num;
    }
    else {
      goods_datas = cart_id;
    }
    // let bundleParams = {
    //   act: 'member_buy',
    //   op: 'step_first',
    //   cart_id: '16407,16408',
    //   ifcart: 1
    // }

    // let defaultParams = {
    //   act: 'member_buy',
    //   cart_id: '4807|1',
    //   op: 'step_first',
    //   ifcart: 0
    // }

    let params = {
      act: 'member_buy',
      op: 'step_first',
      curpage: 1,
      cart_id: goods_datas,
      ifcart,
    }


    getReq(params, function (res) {
      wx.hideLoading()
      if (res.code == 200) {
        let datas = res.datas
        console.log('datas:', datas);
        let { goods_list, summary, bundling } = res.datas
        let n_goods_list = self.getNewGoodsList(goods_list, summary, bundling)

        if (datas.address) {
          let { true_name, mob_phone, area_info, address, address_id } = datas.address;
          appInstance.checkDefaultAddress({
            true_name,
            mob_phone,
            area_info,
            address,
            address_id
          })
        }
        self.setData({
          datas,
          n_goods_list,
          firstLoad: false,
          defaultAddress: datas.address
        })
      }
      else {
        wx.showToast({
          icon: 'none',
          title: res.message,
          duration: 2000
        })
        appInstance.globalData.fcodeErr = res.message
        wx.navigateBack()
      }
    })
  },
  // getGoodsList(summary, goods_list) {
  //   console.log('summary', summary);
  //   console.log('goods_list', goods_list);
  //   let newGoodsList = []
  //   goods_list.map((item, index) => {
  //     summary.find((list, key) => {
  //       if (item.goods_id == list.goods_id) {
  //         let goods_item = list
  //         goods_item.goods_num = item.goods_num
  //         newGoodsList.push(goods_item)
  //         return true
  //       }
  //     })
  //   })
  //   return newGoodsList
  // },
  toPay() {
    if (!this.data.defaultAddress) {
      wx.showToast({
        icon: 'none',
        title: '请填写收货地址',
        duration: 1500
      })
      return
    }
    let goods_id = this.data.goods_id
    let goods_num = this.data.num
    let iscart = this.data.ifcart
    let cart_id = this.data.cart_id

    let vat_hash = this.data.datas['payinfo'].vat_hash
    let offpay_hash = this.data.datas['payinfo'].offpay_hash
    let offpay_hash_batch = this.data.datas['payinfo'].offpay_hash_batch
    let address_id = this.data.defaultAddress.address_id ? this.data.defaultAddress.address_id : this.data.datas['address'].address_id

    let ifcart = cart_id ? 1 : 0
    let cartids = cart_id ? cart_id : (goods_id + '|' + goods_num)
    getReq({
      act: 'member_buy',
      op: 'step_second',
      // payment: 'jspay',
      payment: 'minipay',
      usebonus: 1,
      ifcart,
      cart_id: cartids,
      address_id,
      invoice_id: 0,
      vat_hash,
      offpay_hash,
      offpay_hash_batch
    }, function (res) {
      wx.hideLoading()
      if (res.code == 200) {
        let param = res.datas.param.data
        let pay_sn = res.datas.pay_sn
        console.log(res);
        wx.requestPayment({
          timeStamp: param.timeStamp,         //时间戳，自1970年以来的秒数
          nonceStr: param.nonceStr, //随机串
          package: param.package,
          signType: param.signType,         //微信签名方式：
          paySign: param.paySign, //微信签名
          success: function (res) {
            wx.reLaunch({
              url: "/pages/index/index"
            })
          },
          fail: function (res) {
            wx.redirectTo({
              url: `/pages/orderPaySn/orderPaySn?pay_sn=${pay_sn}`
            })
          }
        });
      }
      else {
        wx.showToast({
          icon: 'none',
          title: res.message,
          duration: 2000
        })
        appInstance.globalData.fcodeErr = res.message
        wx.navigateBack()
      }
    })
  },

  getNewGoodsList(goods_list, summary, bundling) {
    let summaryMap = new Map()
    let bundlingMap = new Map()
    summary.map(item => {
      summaryMap.set(item['goods_id'], item)
    })
    if (bundling.length) {
      bundling.map(item => {
        bundlingMap.set(item['bl_id'], item)
      })
    }
    let n_goods_list = new Bundle(goods_list, summaryMap, bundlingMap).createOrders()
    return n_goods_list
  },

  // testBundle() {
  //   let bundleParams = {
  //     act: 'member_buy',
  //     op: 'step_first',
  //     cart_id: '16407,16408',
  //     ifcart: 1
  //   }

  //   let defaultParams = {
  //     act: 'member_buy',
  //     cart_id: '4807|1',
  //     op: 'step_first',
  //     ifcart: 0
  //   }
  //   let self = this
  //   getReq(bundleParams, function (res) {
  //     console.log('Bundle', res);
  //     if (res.code == 200) {
  //       let { goods_list, summary, bundling } = res.datas
  //       let summaryMap = new Map()
  //       let bundlingMap = new Map()
  //       summary.map(item => {
  //         summaryMap.set(item['goods_id'], item)
  //       })
  //       if (bundling.length) {
  //         bundling.map(item => {
  //           bundlingMap.set(item['bl_id'], item)
  //         })
  //       }
  //       let n_goods_list = new Bundle(goods_list, summaryMap, bundlingMap).createOrders()
  //       console.log('n_goods_list: ', n_goods_list);
  //       self.setData({
  //         n_goods_list
  //       })
  //     }
  //   })
  // },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    if (!this.data.firstLoad) {
      let defaultAddress = appInstance.globalData.defaultAddress
      this.setData({
        defaultAddress
      })
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  }
})