const getReq = require('./../../config.js').getReq
let appInstance = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    order_info: {},
    defaultAddress: null,
    firstLoad: true
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let pay_sn = options.pay_sn;
    this.getDatas(pay_sn);
    console.log(111);
  },
  getDatas(pay_sn) {
    let self = this;
    wx.showLoading({
      title: '加载中',
    })
    getReq({
      act: 'member_order',
      op: 'pay_info',
      pay_sn: pay_sn
    }, function (res) {
      wx.hideLoading();
      if (res.code == 200) {
        self.setData({
          defaultAddress: {
            mob_phone: res.datas.order.reciver_info.mob_phone,
            true_name: res.datas.order.reciver_info.reciver_name,
            area_info: res.datas.order.reciver_info.area,
            address: res.datas.order.reciver_info.street
          },
          order_info: res.datas.order.order_info,
          firstLoad: false
        });
      }
      else {
        wx.showToast({
          icon: 'none',
          title: res.message,
          duration: 2000
        })
      }
    })
  },
  getGoodsList(summary, goods_list) {
    let newGoodsList = []
    goods_list.map((item, index) => {
      summary.find((list, key) => {
        if (item.goods_id == list.goods_id) {
          let goods_item = list
          goods_item.goods_num = item.goods_num
          newGoodsList.push(goods_item)
          return true
        }
      })
    })
    return newGoodsList

  },
  toPay() {
    let params = {
      act: 'member_order',
      op: 'pay',
      pay_sn: this.data['order_info']['pay_sn'],
      payment: 'minipay'
    }
    getReq(params, function (res) {
      if (res.code == 200) {
        let param = res.datas.param.data;
        wx.requestPayment({
          timeStamp: param.timeStamp,         //时间戳，自1970年以来的秒数
          nonceStr: param.nonceStr, //随机串
          package: param.package,
          signType: param.signType,         //微信签名方式：
          paySign: param.paySign, //微信签名
          success: function (res) {
            // wx.showToast({
            //   icon: 'none',
            //   title: res,
            //   duration: 2000
            // })
            wx.reLaunch({
              url: "/pages/index/index"
            })
            console.log("成功：" + res);
            console.log('支付成功')
          },
          fail: function (res) {
            wx.showToast({
              icon: 'none',
              title: res,
              duration: 2000
            })
            console.log("失败：" + res);
          }
        });
      }
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    if (!this.data.firstLoad) {
      let defaultAddress = appInstance.globalData.defaultAddress
      if (defaultAddress) {
        this.setData({
          defaultAddress
        })
      }

    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  }
})